package nc.ui.hr.baod_orders.view;


import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import nc.bs.framework.common.NCLocator;
import nc.desktop.ui.WorkbenchEnvironment;
import nc.hr.utils.OutputDialogUtil;
import nc.hr.utils.SQLHelper;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.ui.pub.ButtonObject;
import nc.ui.pub.ToftPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UILabel;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.beans.ValueChangedEvent;
import nc.ui.pub.beans.ValueChangedListener;
import nc.ui.resa.refmodel.CostCenterTreeRefModel;
import nc.vo.fipub.exception.ExceptionHandler;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.data.ValueUtils;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.MathTool;
import nc.vo.uap.rbac.profile.FunctionPermProfileManager;
import nc.vo.uap.rbac.profile.IFunctionPermProfile;

/**
 * ̯
 * @author YaoYu
 *
 */
public class AccumulationFundAllocationUI extends ToftPanel {
	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private ButtonObject bt_query = new ButtonObject("ѯ", "", 2, "bt_query");
	private ButtonObject bt_insert = new ButtonObject("", "", 2, "bt_insert");
	private ButtonObject bt_update = new ButtonObject("޸", "", 2, "bt_update");
	private ButtonObject bt_output = new ButtonObject("", "", 2, "bt_output");
	private ButtonObject bt_payableBill = new ButtonObject("Ӧ", "", 2, "bt_payableBill");
	private JProgressBar pb;
	private UITablePane tablepanel = null;
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPanel2 = null;
	private UIPanel ivjUIPanel4 = null;
	private UIPanel ivjUIPanel45 = null;
	private UILabel ivjOrgLabel = null;
	private UILabel ivjperiodLabel = null;
	private UIRefPane ivjcostcpanel = null;
	private UIRefPane ivjOrgPanel = null;
	private UIRefPane ivjperiodpanel = null;
	private UITablePane ivjTablePanel = null;
	private String[] subheading = {"","Ա","","ɷѻ","˲","˾","ע"};
	private String orgCode;//ѯ֯
	private String period;//ѯڼ
	private Map<String, Map<String, UFDouble>> beforePsgMoney = null; //ǰ
	private Map<String, Map<String, UFDouble>> afterPsgMoney = null; //
	Map<String,Map<String,String>> middleTableData = null;//м
	public AccumulationFundAllocationUI() {
		initialize();
		tablepanel = getTablePanel();
	}
	
	

	@Override
	public String getTitle() {
		return "̯";
	}

	public void initialize() {
		setLayout(new BorderLayout());
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPanel2(), BorderLayout.CENTER);
		add(getUIPanel4(), BorderLayout.SOUTH);
		setButtons(new ButtonObject[] { this.bt_query,this.bt_insert,this.bt_update,this.bt_payableBill,this.bt_output});//Ӱť
	}
	private UILabel getOrgLabel() {
		if (this.ivjOrgLabel == null) {
			this.ivjOrgLabel = new UILabel();
			this.ivjOrgLabel.setName("pkorg");
			this.ivjOrgLabel.setText("֯");
		}
		return this.ivjOrgLabel;
	}
	
	private UIRefPane getOrgPanel() {
		if (this.ivjOrgPanel == null) {
			//ڵ
			String nodeCode = "60H20104";
			this.ivjOrgPanel = new UIRefPane();
			this.ivjOrgPanel.setName("pkorg");
			this.ivjOrgPanel.setRefNodeName("֯");
			//Ȩ֯
			String[] pkorgs = FunctionPermProfileManager.getInstance().getProfile(WorkbenchEnvironment.getInstance().getLoginUser().getUser_code()).getFuncSubInfo(nodeCode).getFuncPermissionPkorgs();
			this.ivjOrgPanel.getRefModel().setFilterPks(pkorgs);

			this.ivjOrgPanel.setBounds(new Rectangle(100, 20));
			this.ivjOrgPanel.setPreferredSize(new Dimension(170, 20));
			//this.ivjOrgPanel.setMultiSelectedEnabled(true);
				this.ivjOrgPanel.addValueChangedListener(new ValueChangedListener() {
				public void valueChanged(ValueChangedEvent e) {
					AccumulationFundAllocationUI.this.initialize();
				}
			});
		}
		return this.ivjOrgPanel;
	}
	
	private UILabel getperiodclabel() {
		if (this.ivjperiodLabel == null) {
			this.ivjperiodLabel = new UILabel();
			this.ivjperiodLabel.setName("period");
			this.ivjperiodLabel.setText("");
		}
		return this.ivjperiodLabel;
	}
	
	private UIRefPane getperiodpanel() {
		if (this.ivjperiodpanel == null) {
			this.ivjperiodpanel = new UIRefPane();
			this.ivjperiodpanel.setName("period");
			this.ivjperiodpanel.setRefNodeName("ڼ䵵");
			this.ivjperiodpanel.setBounds(new Rectangle(100, 20));
			this.ivjperiodpanel.setPreferredSize(new Dimension(170, 20));
			this.ivjperiodpanel.addValueChangedListener(new ValueChangedListener() {	
				public void valueChanged(ValueChangedEvent e) {
					AccumulationFundAllocationUI.this.initialize();
				}
			});
		}
		return this.ivjperiodpanel;
	}
	
	private UIPanel getUIPanel0() {
		if (this.ivjUIPanel0 == null) {
			try {
				this.ivjUIPanel0 = new UIPanel();
				this.ivjUIPanel0.setLayout(new BorderLayout());
				UIPanel sel = new UIPanel();
				sel.setLayout(new FlowLayout());
				sel.add(getOrgLabel());
				sel.add(getOrgPanel());
				sel.add(getperiodclabel());
				sel.add(getperiodpanel());
				this.ivjUIPanel0.add(sel, BorderLayout.WEST);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel0;
	}
	
	private UIPanel getUIPanel4() {
		if (this.ivjUIPanel4 == null) {
			this.ivjUIPanel4 = new UIPanel();
			this.ivjUIPanel4.setLayout(new BorderLayout());
			this.ivjUIPanel4.add(getUILabel45(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel4;
	}
	
	private UIPanel getUILabel45() {
		if (this.ivjUIPanel45 == null) {
			try {
				this.ivjUIPanel45 = new UIPanel();
				this.ivjUIPanel45.setName("UIPanel3");
				this.ivjUIPanel45.setPreferredSize(new Dimension(0, 10));
				this.ivjUIPanel45.setLayout(new BorderLayout());
				this.ivjUIPanel45.add(getprogressbar(), BorderLayout.EAST);
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel45;
	}
	
	private void handleException(Throwable e) {
		ExceptionHandler.consume(e);
	}
	
	private JProgressBar getprogressbar() {
		if (this.pb == null) {
			this.pb = new JProgressBar();
			this.pb.setIndeterminate(false);
		}
		return this.pb;
	}
	
	private UIPanel getUIPanel2() {
		if (this.ivjUIPanel2 == null) {
			this.ivjUIPanel2 = new UIPanel();
			this.ivjUIPanel2.setLayout(new BorderLayout());
			this.ivjUIPanel2.setPreferredSize(new Dimension(0, 500));
			this.ivjUIPanel2.add(getTablePanel(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel2;
	}
	
	private UITablePane getTablePanel() {
		if (this.ivjTablePanel == null) {
			try {
				this.ivjTablePanel = new UITablePane();
				this.ivjTablePanel.setName("TablePanel");
				this.ivjTablePanel.setLayout(new CardLayout());
			} catch (Throwable ivjExc) {
				
			}
		}
		return this.ivjTablePanel;
	}
	
	private Vector<Object> convertovector(Object[] objArray) {
		if (objArray == null) {
			return null;
		}
		Vector<Object> v = new Vector<Object>(objArray.length);
		for (int i = 0; i < objArray.length; i++) {
			v.addElement(objArray[i]);
		}
		return v;
	}

	@Override
	public void onButtonClicked(ButtonObject bt) {
		try {
			//ֹͣ༭;
			getOrgPanel().stopEditing();
			getperiodpanel().stopEditing();
			orgCode = getOrgPanel().getRefModel().getRefCodeValue();
			Vector periodData = getperiodpanel().getRefModel().getSelectedData();
			if (periodData != null && periodData.size() > 0) {
				Vector v = (Vector) periodData.get(0);
				period = v.get(0).toString();
			}
			if(!"bt_insert".equals(bt.getCode()) && (orgCode == null || period == null)) {
				ExceptionUtils.wrappBusinessException("֯±ѡѡٲ");
			}
			if("bt_query".equals(bt.getCode())) {
				tableProcessing();
			}else if ("bt_insert".equals(bt.getCode())){
				insert();
			}else if ("bt_update".equals(bt.getCode())){
				update(getTablePanel());
			}else if("bt_output".equals(bt.getCode())){
				onoutput();
			}else {
				MessageDialog.showHintDlg(this, "ʾ", "Ӧ");
			}
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}
	
	/**
	 * Ⱦ
	 * @param orgCode
	 * @param period
	 * @throws Exception
	 */
	private void tableProcessing() throws Exception {
		//ʼ
		beforePsgMoney = new HashMap<String, Map<String, UFDouble>>();
		afterPsgMoney = new HashMap<String, Map<String, UFDouble>>();
		middleTableData = new HashMap<String,Map<String,String>>();
		queryMiddleTable();
		String[] m_sTitle = {null,null,null,null,null,null,null,null,null};
		List<Object[]> dataList = new ArrayList<Object[]>();
		for (int i = 0; i < 11; i++) {  
            Object[] row = new Object[0];
            dataList.add(row);  
        }
		Map<String, Map<String,UFDouble>> tableMap = new HashMap<String, Map<String,UFDouble>>();
		List<Map<String,String>> tableOne = queryTableOne(orgCode, period);
		moneyDispose("һɸ˳е", tableOne);
		List<Map<String,String>> tableTwo = queryTableTwo(orgCode, period);
		moneyDispose("ⲿ˾е", tableTwo);
		List<Map<String,String>> tableThree = queryTableThree(orgCode, period);
		moneyDispose("ɲųеȫ˾е", tableThree);
		List<Map<String,String>> tableFour = queryTableFour(orgCode, period);
		moneyDispose("ģ˲ڼ˾۳", tableFour);
		List<Map<String,String>> tableFive = queryTableFive(orgCode, period);
		moneyDispose("壺нʱе¿۵½", tableFive);
		List<Map<String,String>> tableSix = queryTableSix(orgCode, period);
		moneyDispose("ʵѽɵ¹ʸ˲δ", tableSix);
		List<Map<String,String>> tableSeven = queryTableSeven(orgCode, period);
		moneyDispose("ߣʵδɵ¹ʸ˲ѿ", tableSeven);
		List<Map<String,String>> TableEight = queryTableEight(orgCode, period);
		moneyDispose("ˣʵʼ˾ѽɵ¹ʸ˲ѿ", TableEight);
		tableMap.put("tableOne", addTableToList("1-", dataList, "һɸ˳е", tableOne));
		tableMap.put("tableTwo", addTableToList("2-", dataList, "ⲿ˾е", tableTwo));
		tableMap.put("tableThree", addTableToList("3-", dataList, "ɲųеȫ˾е", tableThree));
		tableMap.put("tableFour", addTableToList("4-", dataList, "ģ˲ڼ˾۳", tableFour));
		tableMap.put("tableFive", addTableToList("5-", dataList, "壺нʱе¿۵½", tableFive));
		tableMap.put("tableSix", addTableToList("6-", dataList, "ʵѽɵ¹ʸ˲δ", tableSix));
		tableMap.put("tableSeven", addTableToList("7-", dataList, "ߣʵδɵ¹ʸ˲ѿ", tableSeven));
	    tableMap.put("TableEight",addTableToList("8-", dataList, "ˣʵʼ˾ѽɵ¹ʸ˲ѿ", TableEight));		
		UFDouble tableOneStaff = tableMap.get("tableOne").get("staff");//˳е˲
		UFDouble tableOneOrg = tableMap.get("tableOne").get("org");//˳е˾
		UFDouble tableTwoStaff = tableMap.get("tableTwo").get("staff");//ⲿ˾е˲
		UFDouble tableTwoOrg = tableMap.get("tableTwo").get("org");//ⲿ˾е˾
		UFDouble tableThreeStaff = tableMap.get("tableThree").get("staff");//ųеȫ˾е˲
		UFDouble tableThreeOrg = tableMap.get("tableThree").get("org");//ųеȫ˾е˾
		UFDouble tableFourStaff = tableMap.get("tableFour").get("staff");//˲ڼ˾۳˲
		UFDouble tableFourOrg = tableMap.get("tableFour").get("org");//˲ڼ˾۳˾
		UFDouble tableFiveStaff = tableMap.get("tableFive").get("staff");//нʱе¿۵½ɸ˲
		UFDouble tableFiveOrg = tableMap.get("tableFive").get("org");//нʱе¿۵½ɹ˾
		UFDouble tableSixStaff = tableMap.get("tableSix").get("staff");//ʵѽɵ¹ʸ˲δ۸˲
		UFDouble tableSixOrg = tableMap.get("tableSix").get("org");//ʵѽɵ¹ʸ˲δ۹˾
		UFDouble tableSevenStaff = tableMap.get("tableSeven").get("staff");//ʵδɵ¹ʸ˲ѿ۸˲
		UFDouble tableSevenOrg = tableMap.get("tableSeven").get("org");//ʵδɵ¹ʸ˲ѿ۹˾
		
		UFDouble  queryTableNine = nvl(queryTableNine(orgCode, period), 2);//˹ʱ۽
		Map<String,String> TableTenMap =  queryTableTen(orgCode, period);
		UFDouble TableTenStaff = nvl(TableTenMap.get("so_staff_sum"), 2);//ʵʽ
		UFDouble TableTenOrg =  nvl(TableTenMap.get("so_org_sum"), 2);//˾ʵʽ
		//籣˵ʵʽ = ʵʽ+˾ʵʽ
		UFDouble actualSum = TableTenStaff.add(TableTenOrg);
		//籣̯ = ˳еˡ˾+ⲿ˾еˡ˾+ųеȫ˾еˡ˾+
		//		˲ڼ˾۳ˡ˾+нʱе¿۵½ɸˡ˾+ʵѽɵ¹ʸ˲δ۸ˡ˾  
		UFDouble specialfillSum = tableOneStaff.add(tableOneOrg).add(tableTwoStaff).add(tableTwoOrg).add(tableThreeStaff).add(tableThreeOrg)
				.add(tableFourStaff).add(tableFourOrg).add(tableFiveStaff).add(tableFiveOrg).add(tableSixStaff).add(tableSixOrg);
		//˹ʱ۽̯ = нʱе¿۵½ɸ˲ +ʵδɵ¹ʸ˲ѿ۸˲ + ʵʼ˾ѽɵ¹ʸ˲ѿ۸˲
		UFDouble staffPaymentSum = tableFiveStaff.add(tableSevenStaff);
		//ʵʽ̯ = ˳е˲ + ⲿ˾е˲ +ųеȫ˾е˲ +  ˲ڼ˾۳˲
		//		+нʱе¿۵½ɸ˲ + ʵѽɵ¹ʸ˲δ۸˲
		UFDouble staffActualSum = tableOneStaff.add(tableTwoStaff).add(tableThreeStaff).add(tableFourStaff).add(tableFiveStaff).add(tableSixStaff);
		//˾ʵʽ̯ = ˳е˾ + ⲿ˾е˾ + ųеȫ˾е˾ +  ˲ڼ˾۳˾ +
		//		нʱе¿۵½ɹ˾ + ʵѽɵ¹ʸ˲δ۹˾ + ʵδɵ¹ʸ˲ѿ۹˾
		UFDouble orgActualSum = tableOneOrg.add(tableTwoOrg).add(tableThreeOrg).add(tableFourOrg).add(tableFiveOrg).add(tableSixOrg).add(tableSevenOrg);
		dataList.set(0, new Object[] {"Ϣ"});
		dataList.set(1, new Object[] {"籣˵ʵʽ", actualSum, "籣̯", specialfillSum});
	    dataList.set(2, new Object[] {"˳е", "˾", tableOneOrg, "ⲿ˾е", "˾", tableTwoOrg, "ųеȫ˾е", "˾", tableThreeOrg});
	    dataList.set(3, new Object[] {"˳е", "˲", tableOneStaff, "ⲿ˾е", "˲", tableTwoStaff, "ųеȫ˾е", "˲", tableThreeStaff});
	    dataList.set(4, new Object[] {"˲ڼ˾۳  ", "˾", tableFourOrg, "нʱе¿۵½", "˾", tableFiveOrg, "ʵѽɵ¹ʸ˲δ", "˾", tableSixOrg});
	    dataList.set(5, new Object[] {"˲ڼ˾۳  ", "˲", tableFourStaff, "нʱе¿۵½", "˲", tableFiveStaff, "ʵѽɵ¹ʸ˲δ", "˲", tableSixStaff});
	    dataList.set(6, new Object[] {"ʵδɵ¹ʸ˲ѿ  ", "˾", tableSevenOrg, "ʵʼ˾ѽɵ¹ʸ˲ѿ", "˾", null});
	    dataList.set(7, new Object[] {"ʵδɵ¹ʸ˲ѿ  ", "˲", tableSevenStaff, "ʵʼ˾ѽɵ¹ʸ˲ѿ", "˾", null});
	    dataList.set(8, new Object[] {"", "ʱ۽", queryTableNine, "̯", staffPaymentSum, "", queryTableNine.sub(staffPaymentSum)});
	    dataList.set(9, new Object[] {"", "ʵʽ", TableTenStaff, "̯", staffActualSum, "", TableTenStaff.sub(staffActualSum)});
	    dataList.set(10, new Object[] {"˾", "ʵʽ", TableTenOrg, "̯", orgActualSum, "", TableTenOrg.sub(orgActualSum)});
	    Object[][] dataArray = new Object[dataList.size()][m_sTitle.length];
		for (int i = 0; i < dataList.size(); i++) {
            Object[] rowData = dataList.get(i);
            dataArray[i] = rowData;
        }
		DefaultTableModel model = new DefaultTableModel(dataArray, m_sTitle)
		{
			//еԪ༭
	        @Override
	        public boolean isCellEditable(int row, int column) {
	        	return false;
	        }
	    };
	    tablepanel.getTable().setModel(model);
	    tablepanel.getTable().setColumnWidth(new int[] {300,150,150,280,150,150,190,190,160});
	    
	    TableCellRenderer renderer = new DefaultTableCellRenderer() {
	        @Override  
	        public Component getTableCellRendererComponent(JTable table, Object value,  
	                boolean isSelected, boolean hasFocus, int row, int column) {  
	            // øgetTableCellRendererComponent  
	            super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);  
	            //ʮпʼֵɰɫ,ֵΪɫ
	            if (row >= 13 && column == 7) {
		            // ԪѡУֵͱɫͬδѡʱóɰɫ
		            if (isSelected) {
		                setForeground(Color.decode("#F9E2D0")); 
		            } else {  
		                setForeground(Color.white);  
		            }
	            }else {
	            	setForeground(Color.BLACK);
	            }
	            

	            // Ⱦ  
	            return this;  
	        }  
	    }; 
	    tablepanel.getTable().getColumnModel().getColumn(7).setCellRenderer(renderer);
	}
	
	
	/**
	 * ԱͳƸˡ˾ֽ
	 * @param ListMap
	 */
	private void moneyDispose(String title, List<Map<String,String>> ListMap) {
		for (int i = 0; i < ListMap.size(); i++) {
			Map<String, UFDouble> mapMoney = new HashMap<String, UFDouble>();
			Map<String,String> map = ListMap.get(i);
			String clerkcode = map.get("clerkcode");
			String clerkname = map.get("clerkname");
			String orgName = map.get("orgname");
			String staffMoney = null;
			String orgMoney = null;
			//orgNameܴΪյ,ƴӵʱnullƴӵµַʹĿ㴦
			String combinedField = title + (orgName == null ? "" : orgName) + clerkcode + clerkname;
			
			//ȡм
			Map<String,String> middleTableMap = middleTableData.get(combinedField);
			//middleTableMapΪձʾмΪգʹԭʼݣΪʹм
			if(middleTableMap != null) {
				staffMoney = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("staffsum"))).toString();
				orgMoney = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("orgsum"))).toString();
			}else {
				staffMoney = MathTool.nvl(ValueUtils.getUFDouble(map.get("staffsum"))).toString();
				orgMoney = MathTool.nvl(ValueUtils.getUFDouble(map.get("orgsum"))).toString();
			}
			int staffMoneyLength = staffMoney.substring(staffMoney.indexOf(".") +1).length();//˲Сλ
			int orgMoneyLength = orgMoney.substring(orgMoney.indexOf(".") +1).length();//˾Сλ
			//˲ֻ߹˾Сλ2λҪн
			if(staffMoneyLength > 2 || orgMoneyLength > 2) {
				UFDouble beforePsgStaffMoney = new UFDouble(staffMoney);
				UFDouble beforePsgOrgMoney = new UFDouble(orgMoney);
				//˲ֻ߹˾ִ0.0000,˲ֻ߹˾һ0Ҫн
				if(!MathTool.equals(beforePsgStaffMoney, null) || !MathTool.equals(beforePsgOrgMoney, null)) {
					//ǰclerkcodemapݽ
					if(beforePsgMoney.get(clerkcode) != null) {
						mapMoney = beforePsgMoney.get(clerkcode);
						beforePsgStaffMoney = beforePsgStaffMoney.add(mapMoney.get("beforePsgStaffMoney"));
						beforePsgOrgMoney = beforePsgOrgMoney.add(mapMoney.get("beforePsgOrgMoney"));
					}
					mapMoney.put("beforePsgStaffMoney", beforePsgStaffMoney);
					mapMoney.put("beforePsgOrgMoney", beforePsgOrgMoney);
					beforePsgMoney.put(clerkcode, mapMoney);
				} 
				
			}
		}
	}
	
	/**
	 * ݴȾ
	 * @param dataList
	 * @param title
	 * @param ListMap
	 */
	private Map<String,UFDouble> addTableToList(String str,List<Object[]> dataList, String title, List<Map<String,String>> ListMap) {
		dataList.add(new Object[]{title});  
	    dataList.add(subheading);
	    Map<String,UFDouble> MapMoney = new HashMap<String,UFDouble>();
	    //ϼƲ
	    UFDouble staffTotal = new UFDouble(0.00, 2);
	    UFDouble orgTotal = new UFDouble(0.00, 2);
	    //СƲ
	    UFDouble staffSubtotal = new UFDouble(0.00, 2);
	    UFDouble orgSubtotal = new UFDouble(0.00, 2);
	    for (int i = 0; i < ListMap.size(); i++) {
			Map<String,String> map = ListMap.get(i);
			Map<String, UFDouble> mapMoney = new HashMap<String, UFDouble>();
			String clerkcode = map.get("clerkcode");
			String clerkname = map.get("clerkname");
			String orgName = map.get("orgname");
			String basicssum = MathTool.nvl(ValueUtils.getUFDouble(map.get("basicssum"))).toString();
			String staffsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("staffsum"))).toString();
			String orgsum = MathTool.nvl(ValueUtils.getUFDouble(map.get("orgsum"))).toString();
			String mark = map.get("mark");
			//orgNameܴΪյ,ƴӵʱnullƴӵµַʹĿ㴦
			String combinedField = title + (orgName == null ? "" : orgName) + clerkcode + clerkname;
			UFDouble basicsMoney = new UFDouble(0.00, 2);
			UFDouble staffMoney = new UFDouble(0.00, 2);
			UFDouble orgMoney = new UFDouble(0.00, 2);
			//ȡм
			Map<String,String> middleTableMap = middleTableData.get(combinedField);
			//middleTableMapΪʹм
			if(middleTableMap != null ) {
				basicssum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("basicssum"))).toString();
				staffsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("staffsum"))).toString();
				orgsum = MathTool.nvl(ValueUtils.getUFDouble(middleTableMap.get("orgsum"))).toString();
				mark = middleTableMap.get("mark");
			}
			basicsMoney = nvl(basicssum, 2);
			staffMoney = nvl(staffsum, 2);
			orgMoney= nvl(orgsum, 2);
			int staffsumLength = staffsum.substring(staffsum.indexOf(".") + 1).length();//˲Сλ
			int orgsumLength = orgsum.substring(orgsum.indexOf(".") + 1).length();//˾Сλ
			//˲ֻ߹˾Сλ2λҪн
			if(staffsumLength > 2 || orgsumLength > 2) {
				UFDouble afterPsgStaffMoney = staffMoney;
				UFDouble afterPsgOrgMoney = orgMoney;
				//˲ֻ߹˾ִ0.0000,˲ֻ߹˾һ0Ҫн
				if(!MathTool.equals(afterPsgStaffMoney, null) || !MathTool.equals(afterPsgOrgMoney, null)) {
					//ǰԱmapݽ
					if(afterPsgMoney.get(clerkcode) != null) {
						mapMoney = afterPsgMoney.get(clerkcode);
						afterPsgStaffMoney = afterPsgStaffMoney.add(mapMoney.get("afterPsgStaffMoney"));
						afterPsgOrgMoney = afterPsgOrgMoney.add(mapMoney.get("afterPsgOrgMoney"));					
					}
					//ȡǰ˲ֽ
					UFDouble beforePsgStaffMoney = beforePsgMoney.get(clerkcode).get("beforePsgStaffMoney");
					//ȡǰ˾ֽ
					UFDouble beforePsgOrgMoney = beforePsgMoney.get(clerkcode).get("beforePsgOrgMoney");
					//˲ֽȡǰ˲ֽ˲нȥֵĲ
					if(MathTool.greaterThan(afterPsgStaffMoney, beforePsgStaffMoney)) {
						staffMoney = staffMoney.sub(afterPsgStaffMoney.sub(beforePsgStaffMoney).setScale(2, UFDouble.ROUND_HALF_UP));
					}
					//˾ֽȡǰ˾ֽ˾нȥֵĲ
					if(MathTool.greaterThan(afterPsgOrgMoney, beforePsgOrgMoney)) {
						orgMoney = orgMoney.sub(afterPsgOrgMoney.sub(beforePsgOrgMoney).setScale(2, UFDouble.ROUND_HALF_UP));
					}				
					mapMoney.put("afterPsgStaffMoney", afterPsgStaffMoney);
					mapMoney.put("afterPsgOrgMoney", afterPsgOrgMoney);
					afterPsgMoney.put(clerkcode, mapMoney);
				}
			}
			
			//ͳƺϼ
			staffTotal = staffTotal.add(staffMoney);
			orgTotal = orgTotal.add(orgMoney);			
			if(orgName != null) {
				//֯Ϊ֯СС
				if(i == 0) {
					//֯С
					dataList.add(new Object[] {orgName});
				}else if(!orgName.equals(ListMap.get(i-1).get("orgname"))){
					//ǰ֯һ֯֯С
					//֯С
					dataList.add(new Object[] {orgName});
				}			
				//
				dataList.add(new Object[] {i+1, clerkcode, clerkname, basicsMoney, staffMoney, orgMoney, mark, str+orgName});
				//ͳС
				staffSubtotal = staffSubtotal.add(staffMoney);
				orgSubtotal = orgSubtotal.add(orgMoney);
				if(i+1 == ListMap.size()) {
					//һкһС
					//С
					dataList.add(new Object[] {"С", null, null, null, staffSubtotal, orgSubtotal});
					staffSubtotal = new UFDouble(0.00, 2);
					orgSubtotal = new UFDouble(0.00, 2);
				}else if(!orgName.equals(ListMap.get(i+1).get("orgname"))){
					//ǰ֯һ֯С
					//С
					dataList.add(new Object[] {"С", null, null, null, staffSubtotal, orgSubtotal});
					staffSubtotal = new UFDouble(0.00, 2);
					orgSubtotal = new UFDouble(0.00, 2);
				}
			}else {
				//
				dataList.add(new Object[] {i+1, clerkcode, clerkname, basicsMoney, staffMoney, orgMoney, mark, str});
			}
	    }
	    //ϼ
	    dataList.add(new Object[] {"ϼ", null, null, null, staffTotal, orgTotal});
	    MapMoney.put("staff", staffTotal);
	    MapMoney.put("org", orgTotal);
	    return MapMoney;
	}
	
	
	/**
	 * ѯ˳е
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableOne(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT clerkcode,clerkname,endowment_base AS basicssum,sum_per_cost AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM AS seq, t.CLERKCODE,T1.CLERKNAME,t.ym,sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost,t1.ENDOWMENT_BASE,t1.mark");
		sql.append(" from NC6337.v_data_xz_gjjshare t");
		sql.append(" left join NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 on t1.CLERKCODE=t.CLERKCODE and t1.PAY_MONTH||'-01'=t.ym");
		sql.append(" where");
		sql.append(" t.key = '籣˾˰ۿ' and t.VALUE <> 0 and t.ym='"+period+"'||'-01' and t1.ORGCODE='"+orgCode+"' and t1.ENDOWMENT_BASE is not null");
		sql.append(" group by ROWNUM,t.CLERKCODE, T1.CLERKNAME,t.ym,t1.ENDOWMENT_BASE,t1.mark)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
		
	/**
	 * ѯⲿ˾е
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableTwo(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT clerkcode,clerkname,endowment_base AS basicssum,so_staff_sum AS staffsum,so_org_sum AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM,t.*");
		sql.append(" FROM nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t");
		sql.append(" WHERE");
		sql.append(" t.out_org IS NOT NULL AND t.PAY_MONTH = '"+period+"' AND t.ORGCODE = '"+orgCode+"'");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
		
	/**
	 * ѯɲųеȫ˾е
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableThree(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT clerkcode,clerkname,endowment_base AS basicssum,so_staff_sum AS staffsum,so_org_sum AS orgsum");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM,t2.clerkcode,t2.clerkname,t2.endowment_base,t2.so_staff_sum,t2.so_org_sum");
		sql.append(" FROM");
		sql.append(" (SELECT");
		sql.append(" T.Endowment_Base,T.CLERKCODE,T.CLERKNAME,T.so_org_sum,T.so_staff_sum,T.ORGCODE,T.PAY_MONTH");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY T");
		sql.append(" WHERE");
		sql.append(" T.PK_POST IN ( SELECT T3.PK_POST FROM NC6337.om_post t3 WHERE T3.postname = 'бԱ' )");
		sql.append(" UNION ALL SELECT");
		sql.append(" t1.Endowment_Base,t1.CLERKCODE,t1.CLERKNAME,t1.so_org_sum,t1.so_staff_sum,T1.ORGCODE,t1.PAY_MONTH ");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1");
		sql.append(" WHERE");
		sql.append(" t1.MARK LIKE '%%'");
		sql.append(" ) t2");
		sql.append(" WHERE");
		sql.append(" t2.PAY_MONTH = '"+period+"' AND t2.ORGCODE = '"+orgCode+"'");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	/**
	 * ѯ˲ڼ˾۳
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableFour(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT salocation as orgname,clerkcode,clerkname,endowment_base AS basicssum,so_staff_sum AS staffsum,so_org_sum AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT ROWNUM AS seq,t11.*");
		sql.append(" FROM");
		sql.append(" (SELECT");
		sql.append(" t.CLERKCODE,T1.CLERKNAME,t.ym,decode( t.c_23, 'ൺ컪׾޹˾', 0, sum( nvl( t.VALUE, 0 ) ) ) AS sum_per_cost,");
		sql.append(" t.c_23 AS salocation,decode( t.c_23, 'ൺ컪׾޹˾', t1.so_org_sum + t1.so_staff_sum, t1.so_org_sum ) AS so_org_sum,");
		sql.append(" t1.so_staff_sum,t1.ENDOWMENT_BASE,T1.MARK");
		sql.append(" FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t");
		sql.append(" LEFT JOIN NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.CLERKCODE AND t1.PAY_MONTH || '-01' = t.ym");
		sql.append(" WHERE t.key = '籣˺ϼ'  AND t.VALUE <> 0 AND t.ym = '"+period+"' || '-01' AND t1.ORGCODE = '"+orgCode+"' AND t1.PAY_SOS_ORG <> t.c_23");
		sql.append(" GROUP BY ROWNUM,t.CLERKCODE,T1.CLERKNAME,t.ym,t1.ENDOWMENT_BASE,t1.so_org_sum,t1.so_staff_sum,t.c_23,T1.MARK");
		sql.append(" ORDER BY t.c_23");
		sql.append(" ) t11");
		sql.append(" ORDER BY ROWNUM)");
		return (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	/**
	 * ѯнʱе¿۵½
	 * @param period
	 * @param orgcode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableFive(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("select costorgname as orgname,clerkcode,clerkname,endowment_base AS basicssum, so_staff_sum as staffsum,so_org_sum AS orgsum,mark ");
		sql.append(" FROM");
		sql.append(" ( SELECT t.CLERKCODE,T1.CLERKNAME,t.ym,sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost,T13.Name AS costorgname,t.c_23 AS salocation,");
		sql.append(" t1.so_org_sum - nvl( t15.sum_per_cost, 0 ) - nvl( t16.SO_ORG_SUM, 0 ) AS so_org_sum,t1.ENDOWMENT_BASE,t1.so_staff_sum,t1.mark");
		sql.append(" FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t");
		sql.append(" LEFT JOIN NC6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.CLERKCODE AND t1.PAY_MONTH || '-01' = t.ym");
		sql.append(" LEFT JOIN ( SELECT t12.CLERK_CODE, t12.NC_PK_POST FROM nc6337.monthly_position_gjj t12 WHERE t12.month = to_char( last_day( to_date( '"+period+"', 'yyyy-mm' ) ), 'yyyy-mm-dd' )");
		sql.append(" ) T12 ON t12.CLERK_CODE = t.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" LEFT JOIN nc6337.person_afford_sbgjj t15 ON t15.CLERKCODE = t.CLERKCODE AND t.YM = t15.ym");
		sql.append(" LEFT JOIN nc6337.DEPT_AFFORD_SBGJJ t16 ON t16.CLERKCODE = t.CLERKCODE AND t.YM = t16.PAY_MONTH WHERE");
		sql.append(" t.key IN ( '籣˺ϼ', 'õ籣', '籣˿ۿ', 'õ籣T' ) ");
		sql.append(" AND t.VALUE <> 0 AND t.ym = '"+period+"' || '-01' AND t1.ORGCODE = '"+orgCode+"' AND t1.PAY_SOS_ORG = t.c_23");
		sql.append(" AND t.CLERKCODE NOT IN ( SELECT t11.WORKERCODE FROM nc6337.v_hr_allocationratio_gjjshareF t11 WHERE t11.WA_PERIOD = '"+period+"' || '-01' ) ");
		sql.append(" GROUP BY t.CLERKCODE,T1.CLERKNAME,t.ym,t1.ENDOWMENT_BASE,t1.so_org_sum - nvl( t15.sum_per_cost, 0 ) - nvl( t16.SO_ORG_SUM, 0 ),");
		sql.append(" t1.so_staff_sum,T13.Name,t.c_23,t1.mark");
		sql.append(" UNION ALL SELECT");
		sql.append(" t.WORKERCODE AS CLERKCODE,t1.CLERKNAME,t.WA_PERIOD AS ym,0 AS sum_per_cost,T6.NAME AS costorgname,'Ϻ컪' AS salocation,");
		sql.append(" round( nvl( t1.so_org_sum, 0 ) * nvl( t.perc, 0 ), 3 ) AS so_org_sum,");
		sql.append(" round( nvl( t1.so_staff_sum, 0 ) * nvl( t.perc, 0 ), 3 ) AS so_staff_sum,t1.Endowment_Base,t1.mark");
		sql.append(" FROM");
		sql.append(" nc6337.v_hr_allocationratio_gjjshareF t");
		sql.append(" LEFT JOIN nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t1 ON t1.CLERKCODE = t.WORKERCODE AND t1.PAY_MONTH || '-01' = t.WA_PERIOD");
		sql.append(" LEFT JOIN ( SELECT DISTINCT T5.CODE, T5.NAME, t5.pk_corp FROM nc6337.ORG_CORP T5 ) T6 ON T6.pk_corp = T.COST_ORG");
		sql.append(" WHERE");
		sql.append(" t.WA_PERIOD = '"+period+"' || '-01' AND t1.CLERKNAME IS NOT NULL AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" UNION ALL SELECT");
		sql.append(" t1.CLERKCODE,t1.CLERKNAME,t1.PAY_MONTH || '-01' AS ym,0 AS sum_per_cost,T1.PAY_SOS_ORG AS costorgname,'Ϻ컪' AS salocation,");
		sql.append(" decode( t1.mark, 'Ա', t1.so_org_sum + t1.so_staff_sum, t1.so_org_sum ) AS so_org_sum,0 AS so_staff_sum,");
		sql.append(" t1.Endowment_Base,t1.mark");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1");
		sql.append(" WHERE");
		sql.append(" t1.MARK IN ( 'Ա', 'Ϻ˾е' ) AND t1.PAY_MONTH = '"+period+"'AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" )ORDER BY costorgname");
		return (List<Map<String,String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	/**
	 * ѯʵѽɵ¹ʸ˲δ
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableSix(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT orgname,clerkcode,clerkname,endowment_base AS basicssum,so_staff_sum as staffsum,so_org_sum AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT t1.CLERKCODE,t1.CLERKNAME,t1.Endowment_Base,t1.so_org_sum,t1.so_staff_sum,t1.mark,T13.Name AS orgname");
		sql.append(" FROM");
		sql.append(" nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t1");
		sql.append(" LEFT JOIN (SELECT t12.CLERK_CODE,t12.NC_PK_POST FROM nc6337.monthly_position_gjj t12 WHERE");
		sql.append(" t12.month = to_char( last_day( to_date( '"+period+"', 'yyyy-mm' ) ), 'yyyy-mm-dd' )");
		sql.append(" ) T12 ON t12.CLERK_CODE = t1.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" WHERE");
		sql.append(" t1.CLERKCODE NOT IN (SELECT t2.CLERKCODE FROM(SELECT t.CLERKCODE,sum( nvl( t.VALUE, 0 ) ) AS sumVALUE");
		sql.append(" FROM NC6337.v_data_xz_gjjshare t WHERE t.key IN ( '籣˺ϼ', '籣˿ۿ' ) AND t.ym = '"+period+"' || '-01'");
		sql.append(" GROUP BY t.CLERKCODE ");
		sql.append(" ) t2 WHERE t2.sumVALUE > 0)");
		sql.append(" AND T1.PK_POST NOT IN ( SELECT T3.PK_POST FROM NC6337.om_post t3 WHERE T3.postname IN ( 'бԱ', 'Ա' ) )");
		sql.append(" AND t1.out_org IS NULL AND t1.Endowment_Base <> 0 AND t1.PAY_MONTH = '"+period+"' AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" UNION ALL SELECT");
		sql.append(" t1.CLERKCODE,t1.CLERKNAME,t1.Endowment_Base,t1.so_org_sum,t1.so_staff_sum,t1.mark,T13.Name AS orgname");
		sql.append(" FROM nc6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1 LEFT JOIN (SELECT t12.CLERK_CODE,t12.NC_PK_POST FROM");
		sql.append(" nc6337.monthly_position_gjj t12");
		sql.append(" WHERE");
		sql.append(" t12.month = to_char( last_day( to_date( '"+period+"', 'yyyy-mm' ) ), 'yyyy-mm-dd' ) ");
		sql.append(" ) T12 ON t12.CLERK_CODE = t1.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" WHERE");
		sql.append(" t1.mark LIKE '%%' ");
		sql.append(" AND t1.PAY_MONTH = '"+period+"' AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" )ORDER BY orgname");
		return (List<Map<String,String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	
	
	/**
	 * ѯʵδɵ¹ʸ˲ѿ
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableSeven(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT orgname,clerkcode,clerkname,endowment_base AS basicssum,so_staff_sum as staffsum,so_org_sum AS orgsum,mark");
		sql.append(" FROM");
		sql.append(" (SELECT t1.CLERKCODE,t1.CLERKNAME,t1.Endowment_Base,( t16.sumvalue - t1.so_staff_sum ) AS so_staff_sum,");
		sql.append(" 0 AS so_org_sum,T13.Name AS orgname,t1.mark");
		sql.append(" FROM");
		sql.append(" nc6337.V_SUM_TB_HR_SOCIAL_SECURITY t1");
		sql.append(" LEFT JOIN (SELECT t12.CLERK_CODE,t12.NC_PK_POST FROM nc6337.monthly_position_gjj t12 WHERE");
		sql.append(" t12.month = to_char( last_day( to_date( '"+period+"', 'yyyy-mm' ) ), 'yyyy-mm-dd' )");
		sql.append(" ) T12 ON t12.CLERK_CODE = t1.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" LEFT JOIN nc6337.person_deduction_sbgjj t16 ON t16.CLERKCODE = t1.CLERKCODE AND t1.pay_month || '-01' = t16.ym");
		sql.append(" WHERE");
		sql.append(" t1.CLERKCODE IN (SELECT t2.CLERKCODE FROM (SELECT t.CLERKCODE,sum( nvl( t.VALUE, 0 ) ) AS sumVALUE FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t WHERE t.key IN ( '籣˿ۿ', '籣˺ϼ' ) AND t.ym = '"+period+"' || '-01'");
		sql.append(" GROUP BY t.CLERKCODE");
		sql.append(" ) t2 WHERE t2.sumVALUE > 0)");
		sql.append(" AND T1.PK_POST NOT IN ( SELECT T3.PK_POST FROM NC6337.om_post t3 WHERE T3.postname IN ( 'бԱ', 'Ա' ) )");
		sql.append(" AND t1.out_org IS NULL AND t1.Endowment_Base <> 0 AND ( t16.sumvalue - t1.so_staff_sum ) > 0");
		sql.append(" AND t1.PAY_MONTH = '"+period+"' AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" UNION ALL SELECT");
		sql.append(" t1.CLERKCODE,t1.CLERKNAME,t1.Endowment_Base,t1.so_staff_sum,t1.so_org_sum,T13.Name AS orgname,t1.mark");
		sql.append(" FROM");
		sql.append(" nc6337.V_SUM_TB_HR_SOCIAL_SECURITY_D t1");
		sql.append(" LEFT JOIN (SELECT t12.CLERK_CODE,t12.NC_PK_POST FROM nc6337.monthly_position_gjj t12 WHERE");
		sql.append(" t12.month = to_char( last_day( to_date( '"+period+"', 'yyyy-mm' ) ), 'yyyy-mm-dd' ) ");
		sql.append(" ) T12 ON t12.CLERK_CODE = t1.CLERKCODE");
		sql.append(" LEFT JOIN nc6337.om_post t14 ON t14.pk_post = t12.NC_PK_POST");
		sql.append(" LEFT JOIN nc6337.org_corp T13 ON T13.Pk_Corp = t14.pk_org");
		sql.append(" WHERE");
		sql.append(" t1.mark LIKE '%%'");
		sql.append(" AND t1.PAY_MONTH = '"+period+"' AND t1.ORGCODE = '"+orgCode+"'");
		sql.append(" )ORDER BY orgname");
		return (List<Map<String,String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	/**
	 * ѯʱ۽
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private Object queryTableNine(String orgCode, String period) throws Exception{	
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" sum( nvl( t.VALUE, 0 ) ) AS sum_per_cost");
		sql.append(" FROM");
		sql.append(" NC6337.v_data_xz_gjjshare t");
		sql.append(" WHERE");
		sql.append(" t.key IN ( '籣˺ϼ', 'õ籣', '籣˿ۿ', 'õ籣T' ) AND t.ym = '"+period+"' || '-01'");
		sql.append(" AND t.c_23 = ( SELECT t1.name FROM nc6337.org_corp t1 WHERE t1.code = '"+orgCode+"' )");
		return (Object) iuap.executeQuery(sql.toString(), new ColumnProcessor());
	}
	
	/**
	 * ѯʵʽ
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private Map<String,String> queryTableTen(String orgCode, String period) throws Exception{	
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" *");
		sql.append(" FROM");
		sql.append(" NC6337.V_SUM_TB_HR_SOCIAL_SECURITY_D T");
		sql.append(" WHERE");
		sql.append(" T.CLERKNAME = '' AND T.PAY_MONTH = '"+period+"' AND T.ORGCODE = '"+orgCode+"'");
		Map<String,String> map = (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
		if(map == null) {
			map = new HashMap<String,String>();
			map.put("so_staff_sum", null);
			map.put("so_org_sum", null);
		}
		return map;
	}
	
	/**
	 * ѯмݲ
	 * @return
	 * @throws Exception
	 */
	private void queryMiddleTable() throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" combined_field,basicssum,staffsum,orgsum,mark from accumulation_fund");
		sql.append(" WHERE ");
		sql.append(" tablename = '籣̯' AND combined_field NOT LIKE 'ˣʵʼ˾ѽɵ¹ʸ˲ѿ%'");
		sql.append(" AND orgcode = '" + orgCode + "' AND period = '" + period + "'");
		List<Map<String,String>> listMap = (List<Map<String, String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
		for (int i = 0; i < listMap.size(); i++) {
			Map<String,String> map = listMap.get(i);
			middleTableData.put(map.get("combined_field"), map);
		}
	}
	
	/**
	 * ѯʵʼ˾ѽɵ¹ʸ˲ѿ
	 * @param period
	 * @param orgCode
	 * @return
	 * @throws Exception
	 */
	private List<Map<String,String>> queryTableEight(String orgCode, String period) throws Exception{
		StringBuffer sql = new StringBuffer();
		sql.append("SELECT");
		sql.append(" contributoryorg AS orgname,clerkcode,clerkname,basicssum,staffsum,orgsum,mark");
		sql.append(" FROM");
		sql.append(" accumulation_fund");
		sql.append(" WHERE");
		sql.append(" tablename = '̯' AND combined_field LIKE 'ˣʵʼ˾ѽɵ¹ʸ˲ѿ%'");
		sql.append("  AND orgcode = '" + orgCode + "' AND period = '" + period + "'");
		sql.append(" ORDER BY CONTRIBUTORYORG");
		return (List<Map<String,String>>) iuap.executeQuery(sql.toString(), new MapListProcessor());
	}
	
	/**
	 * ObjectתUFDoubleñλС
	 * @param obj
	 * @param power
	 * @return
	 */
	public UFDouble nvl(Object obj, int power){
		return MathTool.nvl(ValueUtils.getUFDouble(obj)).setScale(2, UFDouble.ROUND_HALF_UP);
	}
	
	/**
	 * ȡ޸ݴ޸Ľ
	 * @param table ޸
	 */
	private void update(UITablePane table) {
		try {
			List<Object[]> selectedData = new ArrayList<Object[]>();
			int rows[] = table.getTable().getSelectedRows();
			if(rows.length == 0) {
				MessageDialog.showHintDlg(this, "ʾ", "ѡҪ޸ĵݣ");
				return;
			}else {
				for (int i = 0; i < rows.length; i++) {
					//С֯ͱΪ8λ
					Object[] rowData = new Object[8];
					for (int j = 0; j < 8; j++) {
						Object obj  = table.getTable().getValueAt(rows[i], 7);
						if(obj == null) {
							MessageDialog.showHintDlg(this, "ʾ", "ѡȷ޸ģ");
							return;
						}
						rowData[j] = table.getTable().getValueAt(rows[i], j);
					}
					selectedData.add(rowData);
				}
			}
			//0ʾʵ޸ģǵر
			 if(new SocialInsuranceAllUpdateDialog(selectedData, orgCode, period).showModal() == 0) {
				//ñѯˢ
				tableProcessing();
				MessageDialog.showHintDlg(this, "ʾ", "޸ĳɹ");
			 }
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}
	
	/**
	 * 
	 */
	private void onoutput() {
		OutputDialogUtil outdig = new OutputDialogUtil(this, getTablePanel(), "̯");
		if (outdig.showModal() == 2) {
			return;
		}
	}
	
	/**
	 * 򿪱ˣʵʼ˾ѽɵ¹ʸ˲ѿҳ
	 */
	private void insert() {
		 try {
			//0ʾʵǵر
			if(new AccumulationFundAllInsertDiaLog().showModal() == 0) {
				MessageDialog.showHintDlg(this, "ʾ", "ɹ");
			 }
		} catch (Exception e) {
			MessageDialog.showHintDlg(this, "ʾ", e.getMessage());
		}
	}
}

